---
title: FetchEvent.navigationPreload
slug: Web/API/FetchEvent/navigationPreload
tags:
  - API
  - FetchEvent
  - Offline
  - Property
  - Reference
  - Service Workers
  - Workers
---
<p>{{SeeCompatTable}}{{APIRef("Service Workers API")}}</p>

<p>The <strong><code>navigationPreload</code></strong> read-only property of the {{domxref("FetchEvent")}} interface returns a {{jsxref("Promise")}} that resolves to the instance of {{domxref("NavigationPreloadManager")}} associated with the current service worker registration.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>promise</em> = <em>fetchEvent</em>.navigationPreload</pre>

<h3 id="Value">Value</h3>

<p>A {{jsxref("Promise")}} that resolves to the instance of {{domxref("NavigationPreloadManager")}}.</p>

<h2 id="Example">Example</h2>

<p>The following example shows the implementation of a fetch event that uses a preloaded response. </p>

<pre>addEventListener('fetch', event =&gt; {
  event.respondWith(async function() {
    // Respond from the cache if we can
    const cachedResponse = await caches.match(event.request);
    if (cachedResponse) return cachedResponse;

    // Else, use the preloaded response, if it's there
    const response = await event.preloadResponse;
    if (response) return response;

    // Else try the network.
    return fetch(event.request);
  }());
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers','#service-worker-registration-navigationpreload','navigationPreload')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.FetchEvent.navigationPreload")}}</p>
</div>
